#!/bin/sh
# $Id: t-cltbind-5.sh,v 1.1 2011/04/29 17:57:00 ca Exp $
# Copyright (c) 2011 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# test client IP address binding: test whether internal data is
# erased properly so a subsequent section does not use stale information.
# ----------------------------------------
#

SD=`dirname $0`
THISDIR=`pwd`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh
SRCPRG=${STE}/smtpc2

chkcto smtpc COMMERCIAL
chkcto smtpc SC_SESS_FEATS

if test X"`uname`" != "XOSF1"
then
while getopts S:s:V FLAG
do
  case "${FLAG}" in
    S) SKIP="${OPTARG}";;
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

getip2 2

cd ../qmgr || exit 1

${CAT} > ${SMXCNF} <<EOF
smtpc { Log_Level = 13; remote_port=${SNKPORT}; wait_for_server=4;
}
smtps {
	Log_Level = 12;
	daemon_address = localhost:${SRVPORT};
	wait_for_server=4;
}
qmgr { Log_Level = 12; wait_for_server=4; wait_for_client=4;
  smtpc {
	source bind0 { ips = { $H2 } }
  }
}
smar { Log_Level = 12; nameserver = ${NS}; }
EOF

# create mailertable (save old version?)
${CAT} > ${MT} <<EOF
local.dom	lmtp:
some.dom	[127.0.0.1]
other.tld	[127.0.0.1]
EOF

# ----------------------------------------
# test: send mails
TEST=1
if echo " ${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false

${CAT} > ${QMGRCONF} <<EOF
smtpc_conf_mail:sender@some.dom	source=bind0;
EOF
rm -f ${QMGRCONFMAP}
${MM} -t'	' -F ${QMGRCONFMAP} < ${QMGRCONF}

SENDER=sender@some.dom
RCPT=user@some.dom
if ${SHELL} ${SD}/smtpcnf.sh -F ${SRVPORT} -S${SENDER} -R${RCPT} -E 1 -X 1 -A 1 -Z "smtpc2" -d 5 -Y "-d 8" -z
then
  if grep "connection from $H2" ${SRVL} >/dev/null
  then

${CAT} > ${QMGRCONF} <<EOF
smtpc_conf_mail:sender@other.tld	source=bind0;
EOF
rm -f ${QMGRCONFMAP}
${MM} -t'	' -F ${QMGRCONFMAP} < ${QMGRCONF}

    # reload map
    pkill -USR1 -U ${USER} qmgr
    sleep 1

    # send another mail: this must NOT cause a bind()
    if ${SRCPRG} -r ${H}:${SRVPORT} -f${SENDER} -R${RCPT} >> ${CLTL} 2>&1
    then
      CNT=`grep -c "connection from $H2" ${SRVL}`
      if test x"$CNT" != "x"
      then
        if test $CNT -ne 1
        then
          ERR=true
          $VERBOSE && echo "$0: too many connections from $H2"
        fi
      else
        ERR=true
        $VERBOSE && echo "$0: cannot count connections from $H2"
      fi
    else
      ERR=true
      $VERBOSE && echo "$0: failed to send second mail"
    fi

  else
    ERR=true
    $VERBOSE && echo "$0: missing connection from $H2"
  fi
else
  ERR=true
fi
${SD}/stopmts.sh
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi
else
  ${VERBOSE} && echo "$0: test ${TEST} SKIPPED"
fi


# ----------------------------------------
# end
if test ${ERRS} -eq 0
then
  exit 0
else
  echo "$0: ${ERRS} error(s)"
  exit 1
fi
