#!/bin/sh
# $Id: t-mt-1.sh,v 1.2 2010/12/08 16:12:44 ca Exp $
#
# ----------------------------------------
# test port specification and default cause in mailertable.
# refers to meta1.org DNS server.
# ----------------------------------------
#

if test X"${MTA_NO_DNS_TEST}" != "X"
then
  echo "SKIPPED: $0: MTA_NO_DNS_TEST is set"
  exit 0
fi

# source directory of this (and other) shell script
SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

SHELL=/bin/sh
test -x /bin/ksh && SHELL=/bin/ksh

# cd to working directory for alias file!
cd ../qmgr || exit 1

# create mailertable (save old version?)
${CAT} > ${MT} <<EOF
meta1.org	{ host=local.meta1.org; flags=no_MX_lookup; port=${SNKPORT}; }
some.dom	{ host=meta1.org; }
EOF

# ----------------------------------------
# test:
TEST=1
ERR=false
if ${SHELL} ${SD}/smtp1.sh -Ssender@some.dom -Rluser@meta1.org -E 1 -X 1 -A 1
then
  :
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi


rm -f ${MTMAP} ${ALIMAP}
# ----------------------------------------
# end
if test ${ERRS} -eq 0
then
  exit 0
else
  echo "$0: ${ERRS} error(s)"
  exit 1
fi
