#!/bin/sh
# $Id: t-sink-tmo-1.sh,v 1.5 2013/11/26 03:09:13 ca Exp $
#
# Copyright (c) 2011 Claus Assmann
#
# By using this file, you agree to the terms and conditions set
# forth in the license/LICENSE.3C file which can be found at the
# top level of this source code distribution.
#
# ----------------------------------------
# test adaptive timeout in DA: multiple stages
# uses smtp1.sh
# ----------------------------------------
#
test -s stop && exit 1
#

if test X"${MTA_NO_SLOW_TEST}" != "X"
then
  echo "SKIPPED: $0: MTA_NO_SLOW_TEST is set"
  exit 0
fi

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

# cd to working directory for alias file!
cd ../qmgr || exit 1

# create aliases
${CAT} > ${ALI} <<EOF
abuse:	local:
postmaster:	local:
user:	local:
sender: local:
EOF
# create map
rm -f ${ALIMAP}
${MM} < ${ALI}
rm -f ${MTMAP}

# ----------------------------------------
# delay sink in MAIL, RCPT, DATA, and dot stage
TEST=1
# cause a timeout by accepting mail slowly
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false
# smtpc timeout: 5 (-O)
# sink timeout: 8 (-K)
if ${SHELL} ${SD}/smtp1.sh -3 lmtpsock -Ssender@local.dom -Rdelay@local.host -Q '-T D=2 -T M=4' -C '-O 5' -s 160 -X 0 -A 1 -E 4 -Y "-K M=8 -K R=8 -K D=8 -K d=8"
then
  # look for timeout error? could be different text...
  if chkc 'reply=$'
  then
    chkc "phase=MAIL,"
  fi
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi
fi


# ----------------------------------------
# end
if test ${ERRS} -eq 0
then
  exit 0
else
  echo "$0: ${ERRS} error(s)"
  exit 1
fi
