/*
 * Copyright (c) 2000-2006 Sendmail, Inc. and its suppliers.
 *	All rights reserved.
 *
 * By using this file, you agree to the terms and conditions set
 * forth in the LICENSE file which can be found at the top level of
 * the sendmail distribution.
 *
 *	$Id: string.h,v 1.23 2013/12/03 00:15:36 ca Exp $
 */

#ifndef SM_STRING_H
#define SM_STRING_H 1

#include "sm/generic.h"
#include "sm/varargs.h"

/* return number of bytes left in a buffer */
#define SPACELEFT(buf, ptr)	(sizeof buf - ((ptr) - buf))

int PRINTFLIKE(3, 4)
sm_snprintf(char *, size_t, const char *, ...);

#if !HAVE_STRLCPY
size_t strlcpy(char *_dst, const char *_src, size_t _len);
#endif
#if !HAVE_STRLCAT
size_t strlcat(char *_dst, const char *_src, size_t _len);
#endif
#if !HAVE_STRSEP || NEED_STRSEP_PROTO
char *strsep(char **_stringp, const char *_delim);
#endif

#if !HAVE_STRCASESTR
char *strcasestr(const char *_s, const char *_find);
#endif

#if 0
// #if !HASSTRERROR
// char *strerror(int _errno);
// #endif
// #if HAVE_STRERROR_R && !HAVE_DECL_STRERROR_R
// # if HAVE_WORKING_STRERROR_R
// char *strerror_r(int _errnum, char *_strerrbuf, size_t _buflen);
// # else
// int strerror_r(int _errnum, char *_strerrbuf, size_t _buflen);
// # endif
// #endif
#endif /* 0 */

longlong_T	sm_strtoll(const char *, char**, int);
ulonglong_T	sm_strtoull(const char *, char**, int);

#define sm_streqn(s1, s2, l)	(strncmp((s1), (s2), (l)) == 0)
#define sm_streq(s1, s2)	(strcmp((s1), (s2)) == 0)
#define sm_strcaseeqn(s1, s2, l) (strncasecmp((s1), (s2), (l)) == 0)
#define sm_strcaseeq(s1, s2)	(strcasecmp((s1), (s2)) == 0)

char	*sm_getnextstring(char **_cpp);

#define SM_STRDUP_OPT(par, optarg)	\
	do {				\
		par = strdup(optarg);	\
		if (NULL == (par)) {			\
			sm_io_fprintf(smioerr, "strdup(%s) failed\n", optarg);\
			exit(EX_OSERR);		\
		}			\
	} while (0)

#endif /* SM_STRING_H */
