#include "sm/generic.h"
SM_RCSID("@(#)$Id: t-arg2reply-0.c,v 1.3 2010/02/21 23:28:29 ca Exp $")
#include "sm/assert.h"
#include "sm/error.h"
#include "sm/smreplycodes.h"
#include "sm/enhsc.h"
#include "sm/io.h"
#include "sm/test.h"

static int Verbosity = 0;

#define LEN	256

struct tr_S {
	char *e_string;
	char *e_result;
	char *e_enhsc;
};
typedef struct tr_S tr_T;

static tr_T trs[] = {
	{ "550",			"550 oops\r\n",			"550 5.5.0 oops\r\n"},
	{ "450",			"450 oops\r\n",			"450 4.5.0 oops\r\n"},
	{ "450_abc",		"450 abc\r\n",			"450 4.5.0 abc\r\n"},
	{ "450_ab\\033c",	"450 ab\033c\r\n",		"450 4.5.0 ab\033c\r\n"},
	{ "450_4.5.1_abc",	"450 4.5.1 abc\r\n",	"450 4.5.1 abc\r\n"},
	{ NULL, NULL, NULL}
};

static void
test(bool enhsc)
{
	int i;
	char *s, *r;

	for (i = 0; trs[i].e_string != NULL; i++) {
		s = arg2smtpreply(trs[i].e_string, "oops", enhsc);
		SM_TEST_E(s != NULL);
		r = enhsc ? trs[i].e_enhsc : trs[i].e_result,
		SM_TEST(strcmp(r, s) == 0);
		if (strcmp(r, s))
			sm_io_fprintf(smioerr, "e=\"%s\", s=\"%s\"\n", r, s);
		free(s);
	}
  error:
	return;
}

int
main(int argc, char *argv[])
{
	int c;
	bool enhsc;

	enhsc = false;
	while ((c = getopt(argc, argv, "eV")) != -1) {
		switch (c) {
		  case 'e': enhsc = true; break;
		  case 'V':
			++Verbosity;
			break;
		}
	}
	sm_test_begin(argc, argv, "test arg2reply");

	argc -= optind;
	argv += optind;

	test(enhsc);
	test(true);

	return sm_test_end();
}
