/*
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: t-enhsc-0.c,v 1.2 2013/12/21 15:08:31 ca Exp $")
#include "sm/assert.h"
#include "sm/error.h"
#include "sm/misc.h"
#include "sm/enhsc.h"
#include "sm/test.h"

static int Verbosity = 0;

#define LEN	256

struct enhsc_S {
	char *e_string;
	char *e_result;
};
typedef struct enhsc_S enhsc_T;

static enhsc_T enhscs[] = {
	{ "",	NULL},
	{ "a ",	NULL},
	{ "5 ",	NULL},
	{ "5.1 ",	NULL},
	{ "5.1.a ",	NULL},
	{ "3.1.0 ",	NULL},
	{ "4.1.0",	NULL},
	{ "4.1a.0 ",	NULL},
	{ "41.1.0 ",	NULL},
	{ "4.1.0 ",	"4.1.0"},
	{ "5.1.9 ",	"5.1.9"},
	{ "5.123.109 ",	"5.123.109"},
	{ "5.987.654 ",	"5.987.654"},
	{ "5.000.000 ",	"5.000.000"},
	{ NULL, NULL}
};

static void
test(void)
{
	int r, i;
	char enhsc[10];

	for (i = 0; enhscs[i].e_string != NULL; i++) {

		r = isenhsc(enhscs[i].e_string, ' ');
		if (NULL == enhscs[i].e_result)
			SM_TEST(0 == r);
		else
			SM_TEST(r > 4);

		r = extenhsc(enhscs[i].e_string, ' ', enhsc);
		if (NULL == enhscs[i].e_result)
			SM_TEST(0 == r);
		else
			SM_TEST(strcmp(enhscs[i].e_result, enhsc) == 0);
	}
	return;
}

int
main(int argc, char *argv[])
{
	int c;

	while ((c = getopt(argc, argv, "V")) != -1) {
		switch (c) {
		  case 'V':
			++Verbosity;
			break;
		}
	}
	sm_test_begin(argc, argv, "test enhanced status codes");

	argc -= optind;
	argv += optind;

	test();

	return sm_test_end();
}
